<?php

namespace Spec\Infomaker\Everyware\Support;

use Infomaker\Everyware\Support\Arr;
use PhpSpec\ObjectBehavior;
use Prophecy\Argument;

class ArrSpec extends ObjectBehavior
{
    function it_is_initializable()
    {
        $this->shouldHaveType(Arr::class);
    }

    private function get_mixed_array(): array
    {
        return [
            'string', '', false, null, 5
        ];
    }
    public function it_can_detect_whether_the_array_has_integer_keys() {
        $integer_keys_arr = $this->get_mixed_array();

        $this->hasStringKeys($integer_keys_arr)->shouldReturn(false);
    }

    function it_can_detect_whether_the_array_has_non_integer_keys() {

        $integer_keys_arr = $this->get_mixed_array();

        foreach ($integer_keys_arr as $i => $value) {
            $non_integer_keys_arr["key_{$i}"] = $value;
        }

        $this->hasStringKeys($non_integer_keys_arr)->shouldReturn(true);
    }

    public function it_should_detect_whether_keys_are_are_stringified_integers()
    {
        $integer_keys_arr = $this->get_mixed_array();

        foreach ($integer_keys_arr as $i => $value) {
            $non_integer_keys_arr[(string)$i] = $value;
        }

        $this->hasStringKeys($non_integer_keys_arr)->shouldReturn(false);
    }
}
